import { FileSaverOptions } from 'file-saver';
import * as _angular_core from '@angular/core';
import { OnInit } from '@angular/core';
import { HttpResponse } from '@angular/common/http';
import { Observable } from 'rxjs';

declare class FileSaverService {
    get isFileSaverSupported(): boolean;
    genType(fileName?: string | null): string;
    save(blob: Blob | null, fileName?: string, filtType?: string, option?: FileSaverOptions): void;
    saveText(txt: string, fileName?: string, option?: FileSaverOptions): void;
    static ɵfac: _angular_core.ɵɵFactoryDeclaration<FileSaverService, never>;
    static ɵprov: _angular_core.ɵɵInjectableDeclaration<FileSaverService>;
}

declare class FileSaverDirective implements OnInit {
    private readonly ngZone;
    private readonly el;
    private readonly fss;
    private readonly httpClient;
    readonly method: _angular_core.InputSignal<string>;
    readonly http: _angular_core.InputSignal<Observable<HttpResponse<Blob>> | undefined>;
    readonly query: _angular_core.InputSignal<any>;
    readonly header: _angular_core.InputSignal<any>;
    readonly url: _angular_core.InputSignal<string>;
    readonly fileName: _angular_core.InputSignal<string | undefined>;
    readonly fsOptions: _angular_core.InputSignal<FileSaverOptions | undefined>;
    private successEmitter;
    readonly success: _angular_core.OutputRef<HttpResponse<Blob>>;
    private errorEmitter;
    readonly error: _angular_core.OutputRef<any>;
    private readonly d$;
    constructor();
    ngOnInit(): void;
    private getName;
    setDisabled(status: boolean): void;
    private setupClickListener;
    static ɵfac: _angular_core.ɵɵFactoryDeclaration<FileSaverDirective, never>;
    static ɵdir: _angular_core.ɵɵDirectiveDeclaration<FileSaverDirective, "[fileSaver]", ["fileSaver"], { "method": { "alias": "method"; "required": false; "isSignal": true; }; "http": { "alias": "http"; "required": false; "isSignal": true; }; "query": { "alias": "query"; "required": false; "isSignal": true; }; "header": { "alias": "header"; "required": false; "isSignal": true; }; "url": { "alias": "url"; "required": true; "isSignal": true; }; "fileName": { "alias": "fileName"; "required": false; "isSignal": true; }; "fsOptions": { "alias": "fsOptions"; "required": false; "isSignal": true; }; }, { "success": "success"; "error": "error"; }, never, never, true, never>;
}

declare class FileSaverModule {
    static ɵfac: _angular_core.ɵɵFactoryDeclaration<FileSaverModule, never>;
    static ɵmod: _angular_core.ɵɵNgModuleDeclaration<FileSaverModule, never, [typeof FileSaverDirective], [typeof FileSaverDirective]>;
    static ɵinj: _angular_core.ɵɵInjectorDeclaration<FileSaverModule>;
}

export { FileSaverDirective, FileSaverModule, FileSaverService };
